#!/usr/bin/env python
import inspect
import sys
from public import public


@public
def caller_modules():
    try:
        frames = inspect.getouterframes(inspect.currentframe())
        frames = frames[1:]  # remove sys.modules[__name__]
        modules = []
        # for frame, filename, line_number, function_name, lines, index in
        # frames:
        for frame, _, _, _, _, _ in frames:
            # print ""
            # print "frame",frame,line_number,getmodule(frame)
            module = inspect.getmodule(frame)
            if not module:
                continue
            if module in modules:
                continue
            if module != sys.modules[__name__]:
                modules.append(module)
        return modules
    except IndexError:
        return []


@public
def caller_module(depth=0):
    # top module: sys.modules["__main__"]
    modules = caller_modules()[1:]  # exclude parent module
    if depth < len(modules):
        return modules[depth]
